ArrayList<Donald> donaldList;
ArrayList <Bullet> bulletList;
//Rocket rocket = new Rocket (1000, 682);
Rocket rocket;
int state = -1;
int score = 0;

PImage img;

void setup() {
  size(1000, 682);
  donaldList = new ArrayList<Donald>();
  bulletList = new ArrayList<Bullet>();
  rocket = new Rocket (1000, 682);
  img = loadImage("wall.jpg");
  img.resize(1000, 682);
  donaldRestart();
}

void draw() {
  if (state == -1) {
  welcome();
  } 
  
  if (state == 0) {
    game();
  } else if (state == 1) {
    gameOver();
  }
}

void welcome() {
  //img = loadImage("PutinVsDonald.jpg");
  background(img);
  textSize(30);
  text(" Dont let Donald make the wall, press 's' to start :D ", 50, 50);
} 

void game() {
  if (donaldList.size() < 10) {
    donaldList.add(new Donald(width, height));
  }
  img = loadImage("background.jpg");
  img.resize(1000, 682);
  background(img);
  fill(0);
  rocket.movement();
  rocket.display();
 
  text(" Ur score is " + score , 50,50);

  for (int i = bulletList.size()-1; i>=0; i--) {
    Bullet localBullet = bulletList.get(i);

    for (int j = donaldList.size()-1; j>=0; j--) {
      Donald donald = donaldList.get(j);
      if (localBullet.collideDonald(donald)) {
        donaldList.remove(j);
        
        score = score +1;
      }
    }

    if (localBullet.isOutOfWindow()) {
      bulletList.remove(i);
    }

    localBullet.movement();
    localBullet.display();
  }



  for (int i = donaldList.size()-1; i>=0; i--) {
    Donald donald = donaldList.get(i);
    donald.movement();
    donald.display();

    if (rocket.collideDonald(donald)) {
      println(" Rocket got hit");
      donaldList.remove(i);  
      state = 1;
    }

    if (donald.isOutOfWindow()) {
      donaldList.remove(i);
    }
  }
}
//state 1 
void gameOver() {
  img = loadImage("frog.png");
  img.resize(900, 600);
  background(0);
  image(img,0,0);
  textSize(40);
  fill(200);
  text("GAME OVER !", 30, 50);
  text("Press 'r' to restart", 30, 80);
  text("Ur score is " + score, 30, 120);
}

void donaldRestart()
{
  donaldList.clear();
  for (int i = 0; i < 10; i++) {
    donaldList.add(new Donald(width, height));
  } 
  rocket = new Rocket(width, height);
  score = 0;
}



void keyPressed() {
  rocket.keyPresse();

  if (key==' ') {
    bulletList.add(new Bullet(rocket.posX, rocket.posY));
    println(bulletList.size());
  }

  //state management
  if (state == -1 && key == 's') {
    state = 0;
  }
  if (state == 1 && key == 'r') {
    state = 0;
    donaldRestart();
  }
}

void keyReleased() {
  //rocket.keyRelease();
}
