class Bullet {

  //class variables
  float posX;
  float posY;
  float velX;
  float velY = -3;

  //constructor
  Bullet(float _posX, float _posY)
  {
    posX = _posX;
    posY = _posY;
  }

  //class functions    
  void movement() {
    posX = posX + velX;
    posY = posY + velY;
  }

  void display() {
    rect(posX, posY, 5, 10);
  }

  boolean collideDonald(Donald testDonald) {
    if (dist(posX, posY, testDonald.posX, testDonald.posY) < testDonald.size/2 + 3) {
      return true;
    } else {
      return false;
    }
  }

  boolean isOutOfWindow() {
    if (posX < 0 || posX > width || posY < 0 || posY > height) {
      return true;
    } else {
      return false;
    }
  }
}
