class Rocket {
  float posX;
  float posY;
  float velX;
  float velY;
  float size ;
  PImage img;

  Rocket(int _width, int _height) {
    posX = _width/2;
    posY = _height/2;
    velX = 0;
    velY = 0;

    img = loadImage("unicorn.png");
    img.resize(40, 40);
  }
  void display() {
    //fill(255);
    //triangle(posX, posY-15, posX+10, posY+10, posX-10, posY+10);

    image(img, posX, posY);
  }
  void movement() {
    posX = posX + velX;
    posY = posY + velY; 
    //velX = velX * 1;
    //velY = velY * 1;

    if (velX < 0.001 && velX > -0.001) {
      velX= 0;
    }
    if (velY < 0.001 && velY > -0.001) {
      velY= 0;
    }
  }

  boolean collideDonald(Donald testDonald) {
    if (dist(posX, posY, testDonald.posX, testDonald.posY) < testDonald.size/2 + 11) {
      return true;
    } else {
      return false;
    }
  }



  void keyPresse() {
    if (key == CODED) {
      if (keyCode == UP) {
        velY = -4;
      } else if (keyCode == DOWN) {
        velY = 4;
      } else if (keyCode == LEFT) {
        velX = -4;
      } else if (keyCode == RIGHT) {
        velX = 4;
      }
    }
  }

  void keyRealease() {
    if (key== CODED) {
      if (keyCode == UP) {
        velY= -1;
      } else if (keyCode == DOWN) {
        velY = 1;
      } else if (keyCode == LEFT) {
        velX = -1;
      } else if (keyCode == RIGHT) {
        velX = 1;
      }
    }
  }
}
